#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2300seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2300seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven23004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven23004xi = {
                1:'-1050x-1638y1226z',
                2:'-1081x-1873y782z',
                3:'-1127x-1570y1245z',
                4:'-116x-2221y585z',
                5:'-1173x-1807y804z',
                6:'-1175x-1976y5z',
                7:'-1200x-1499y1264z',
                8:'-1261x-1736y825z',
                9:'-1268x-1425y1284z',
                10:'-1277x-1912y28z',
                11:'-1332x-1347y1303z',
                12:'-1345x-1661y847z',
                13:'-1375x-1842y51z',
                14:'-1391x-1267y1322z',
                15:'-1425x-1582y868z',
                16:'-1445x-1184y1340z',
                17:'-1469x-1767y74z',
                18:'-1494x-1099y1359z',
                19:'-1499x-1499y889z',
                20:'-152x-1149y1986z',
                21:'-1538x-1012y1377z',
                22:'-1559x-1687y97z',
                23:'-1569x-1413y910z',
                24:'-1577x-923y1396z',
                25:'-1611x-832y1414z',
                26:'-1634x-1323y931z',
                27:'-1639x-741y1432z',
                28:'-1645x-1602y120z',
                29:'-1662x-649y1450z',
                30:'-1680x-556y1468z',
                31:'-1693x-1230y952z',
                32:'-1693x-464y1485z',
                33:'-1700x-371y1503z',
                34:'-1725x-1513y143z',
                35:'-1747x-1134y973z',
                36:'-1795x-1036y994z',
                37:'-1801x-1420y166z',
                38:'-1838x-936y1015z',
                39:'-1871x-1323y189z',
                40:'-1875x-835y1035z',
                41:'-1907x-732y1056z',
                42:'-1932x-628y1076z',
                43:'-1936x-1222y212z',
                44:'-1952x-523y1097z',
                45:'-1966x-417y1117z',
                46:'-1974x-312y1137z',
                47:'-1976x-207y1157z',
                48:'-1996x-1118y234z',
                49:'-202x-2038y1046z',
                50:'-2049x-1011y257z',
                51:'-2097x-901y280z',
                52:'-209x-1120y1997z',
                53:'-2138x-789y303z',
                54:'-2174x-675y326z',
                55:'-21x-22y2299z',
                56:'-2203x-559y349z',
                57:'-22x-328y2276z',
                58:'-231x-2206y607z',
                59:'-262x-1088y2009z',
                60:'-306x-2014y1066z',
                61:'-313x-1053y2020z',
                62:'-32x-1198y1962z',
                63:'-346x-2184y629z',
                64:'-34x-41y2299z',
                65:'-361x-1016y2031z',
                66:'-36x-304y2279z',
                67:'-406x-977y2041z',
                68:'-409x-1984y1087z',
                69:'-448x-936y2052z',
                70:'-458x-2157y651z',
                71:'-46x-61y2298z',
                72:'-486x-893y2062z',
                73:'-48x-279y2282z',
                74:'-510x-1950y1107z',
                75:'-522x-849y2072z',
                76:'-554x-804y2082z',
                77:'-55x-83y2297z',
                78:'-569x-2124y673z',
                79:'-57x-254y2285z',
                80:'-582x-757y2092z',
                81:'-5x-351y2272z',
                82:'-5x-5y2299z',
                83:'-607x-709y2101z',
                84:'-608x-1910y1127z',
                85:'-629x-661y2110z',
                86:'-63x-105y2296z',
                87:'-643x-118y2204z',
                88:'-648x-613y2119z',
                89:'-64x-228y2287z',
                90:'-657x-157y2198z',
                91:'-663x-564y2128z',
                92:'-669x-197y2191z',
                93:'-674x-516y2137z',
                94:'-677x-2085y695z',
                95:'-679x-239y2184z',
                96:'-683x-468y2145z',
                97:'-685x-283y2177z',
                98:'-688x-420y2153z',
                99:'-689x-327y2169z',
                100:'-68x-129y2295z',
                101:'-690x-373y2161z',
                102:'-69x-203y2289z',
                103:'-703x-1865y1147z',
                104:'-71x-153y2293z',
                105:'-71x-178y2291z',
                106:'-783x-2040y717z',
                107:'-795x-1815y1167z',
                108:'-879x-741y1991z',
                109:'-884x-1760y1187z',
                110:'-885x-1989y739z',
                111:'-890x-834y2066z',
                112:'-900x-682y2003z',
                113:'-918x-622y2014z',
                114:'-932x-563y2025z',
                115:'-93x-1175y1974z',
                116:'-942x-504y2036z',
                117:'-949x-445y2046z',
                118:'-952x-387y2057z',
                119:'-95x-2056y1025z',
                120:'-969x-1701y1206z',
                121:'-985x-1933y760z',
                122:'0x-2230y562z'}
         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2300seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2300seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2300SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2300SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2300SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2300SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2300SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven23004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2300SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2300SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2300SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven23004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven23004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2300SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2300SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2300SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2300seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       